package barricade_items
{
	function gameConnection::onDeath(%client, %killerPlayer, %killer, %damageType, %unknownA)
	{
		if(%client.barricade_bricks > 0)
		{
			for(%i=0;%i<%client.barricade_bricks; %i++)
			{
				%brick = new Item()
				{
					datablock = brick_dropable_Item;
					canPickup = false;
					position = vectoradd(%client.player.getPosition(), getRandom(-3, 3) SPC getrandom(-3, 3) SPC 3);
				};
				%brick.setVelocity("0 0 1");
				MissionCleanup.add(%brick);
				schedule($pref::barricades::itemdeletetime, 0, "eval", "if(isObject(" @ %brick.getID() @ ")) { " @ %brick.getID() @ ".delete(); }");
			}
			%client.barricade_bricks = 0;
		}
		if(%client.barricade_planks > 0)
		{
			for(%i=0;%i<%client.barricade_planks; %i++)
			{
				%plank = new Item()
				{
					datablock = plank_dropable_Item;
					canPickup = false;
					position = vectoradd(%client.player.getPosition(), getRandom(-4, 4) SPC getrandom(-4, 4) SPC 3);
				};
				%plank.setVelocity("0 0 1");
				MissionCleanup.add(%plank);
				schedule($pref::barricades::itemdeletetime, 0, "eval", "if(isObject(" @ %plank.getID() @ ")) { " @ %plank.getID() @ ".delete(); }");
			}
			%client.barricade_planks = 0;
		}
		if(%client.barricade_nails > 0)
		{
			for(%i=0;%i<%client.barricade_nails; %i++)
			{
				%nail = new Item()
				{
					datablock = nail_dropable_Item;
					canPickup = false;
					position = vectoradd(%client.player.getPosition(), getRandom(-2, 2) SPC getrandom(-2, 2) SPC 3);
				};
				%nail.setVelocity("0 0 1");
				MissionCleanup.add(%nail);
				schedule($pref::barricades::itemdeletetime, 0, "eval", "if(isObject(" @ %nail.getID() @ ")) { " @ %nail.getID() @ ".delete(); }");
			}
			%client.barricade_nails = 0;
		}
		if(%client.barricade_logs > 0)
		{
			for(%i=0;%i<%client.barricade_logs; %i++)
			{
				%log = new Item()
				{
					datablock = log_dropable_Item;
					canPickup = false;
					position = vectoradd(%client.player.getPosition(), getRandom(-3, 3) SPC getrandom(-3, 3) SPC 3);
				};
				%log.setVelocity("0 0 1");
				MissionCleanup.add(%log);
				schedule($pref::barricades::itemdeletetime, 0, "eval", "if(isObject(" @ %log.getID() @ ")) { " @ %log.getID() @ ".delete(); }");
			}
			%client.barricade_logs = 0;
		}

		if(%client.barricade_braces > 0)
		{
			for(%i=0;%i<%client.barricade_braces; %i++)
			{
				%brace = new Item()
				{
					datablock = brace_dropable_Item;
					canPickup = false;
					position = vectoradd(%client.player.getPosition(), getRandom(-3, 3) SPC getrandom(-3, 3) SPC 3);
				};
				%brace.setVelocity("0 0 1");
				MissionCleanup.add(%brace);
				schedule($pref::barricades::itemdeletetime, 0, "eval", "if(isObject(" @ %brace.getID() @ ")) { " @ %brace.getID() @ ".delete(); }");
			}
			%client.barricade_braces = 0;
		}
		
		parent::onDeath(%client, %killerPlayer, %killer, %damageType, %unknownA);
	}
	
	function Armor::onCollision(%this, %obj, %col, %thing, %other)
	{
		if(%col.getDatablock().getName() $= "Brick_dropable_Item")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					if(!%col.canPickup)
					{
						return;
					}
					if(%obj.client.minigame) //not having this costed me a lot of trouble and time lol
					{
						%col.minigame = %obj.client.minigame;
					}
					%client = %obj.client;
					%client.barricade_bricks = %client.barricade_bricks + 1;
					%infoMessage = "\c6You have obtained a brick, so you now have \c3" @ %client.barricade_bricks @ " \c6bricks.";
					
					if(isObject(%col.spawnbrick))
					{
						%col.fadeOut();
						%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
					}		
					else
					{
						%col.schedule(10, delete);
					}
					%this.onPickup(%obj, %player);
					%return = true;
				}
			}
		}
		else if(%col.getDataBlock().getName() $= "Plank_dropable_Item")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					if(!%col.canPickup)
					{
						return;
					}
					if(%obj.client.minigame)
					{
						%col.minigame = %obj.client.minigame;
					}
					%client = %obj.client;
					%client.barricade_planks = %client.barricade_planks + 1;
					%infoMessage = "\c6You have obtained a plank, so you now have \c3" @ %client.barricade_planks @ " \c6planks.";
					
					if(isObject(%col.spawnbrick))
					{
						%col.fadeOut();
						%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
					}		
					else
					{
						%col.schedule(10, delete);
					}
					%this.onPickup(%obj, %player);
					%return = true;
				}
			}
		}
		else if(%col.getDataBlock().getName() $= "nail_dropable_Item")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					if(!%col.canPickup)
					{
						return;
					}
					if(%obj.client.minigame)
					{
						%col.minigame = %obj.client.minigame;
					}
					%client = %obj.client;
					%client.barricade_nails = %client.barricade_nails + 1;
					%infoMessage = "\c6You have obtained a nail, so you now have \c3" @ %client.barricade_nails @ " \c6nails.";
					
					if(isObject(%col.spawnbrick))
					{
						%col.fadeOut();
						%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
					}		
					else
					{
						%col.schedule(10, delete);
					}
					%this.onPickup(%obj, %player);
					%return = true;
				}
			}
		}
		else if(%col.getDataBlock().getName() $= "log_dropable_Item")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					if(!%col.canPickup)
					{
						return;
					}
					if(%obj.client.minigame)
					{
						%col.minigame = %obj.client.minigame;
					}
					%client = %obj.client;
					%client.barricade_logs = %client.barricade_logs + 1;
					%infoMessage = "\c6You have obtained a log, so you now have \c3" @ %client.barricade_logs @ " \c6logs.";
					
					if(isObject(%col.spawnbrick))
					{
						%col.fadeOut();
						%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
					}		
					else
					{
						%col.schedule(10, delete);
					}
					%this.onPickup(%obj, %player);
					%return = true;
				}
			}
		}
		else if(%col.getDataBlock().getName() $= "brace_dropable_Item")
		{
			if(isObject(%obj.client))
			{
				if(isObject(%col))
				{
					if(!%col.canPickup)
					{
						return;
					}
					if(%obj.client.minigame)
					{
						%col.minigame = %obj.client.minigame;
					}
					%client = %obj.client;
					%client.barricade_braces = %client.barricade_braces + 1;
					%infoMessage = "\c6You have obtained a brace, so you now have \c3" @ %client.barricade_braces @ " \c6braces.";
						
					if(isObject(%col.spawnbrick))
					{
						%col.fadeOut();
						%col.schedule(%col.spawnbrick.itemrespawntime, "fadeIn");
					}		
					else
					{
						%col.schedule(10, delete);
					}
					%return = true;
					%this.onPickup(%obj, %player);
				}
			}
		}
		if(isObject(%obj.client))
		{
			if(isObject(%col))
			{
				if(%col.getClassName() $= "Item")
				{
					if(%obj.client.canCraftBarricades())
					{
						%infomessage = %infomessage @ "\n" @ "\c5You are able to make these barricades:" @ "\n" @ strReplace(%obj.client.getCraftableBarricadesString(), " ", "\c3, \c4");
					}
					commandtoclient(%obj.client, 'centerprint', %infoMessage, 2);
				}
			}
		}
		if(%return)
		{
			return;
		}
		parent::onCollision(%this, %obj, %col, %thing, %other);
	}
};
activatePackage(barricade_items);

datablock ItemData(brick_dropable_Item)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "./brick.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	
	image = brick_dropable_Image;
	candrop = true;
	canPickup = false;
	uiname = "Brick";
};

datablock ShapeBaseImageData(brick_dropable_Image)
{
	shapeFile = "./brick.dts";
	emap = true;
	
	canPickup = false;
};

datablock ItemData(plank_dropable_Item)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "./plank.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiname = "Plank";
	
	image = plank_dropable_Image;
	candrop = true;
	canPickup = false;
};

datablock ShapeBaseImageData(plank_dropable_Image)
{
	shapeFile = "./plank.dts";
	emap = true;
	
	canPickup = false;
};


datablock ItemData(nail_dropable_Item)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "./nail.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiname = "Nail";
	
	image = nail_dropable_Image;
	candrop = true;
	canPickup = false;
};

datablock ShapeBaseImageData(nail_dropable_Image)
{
	shapeFile = "./nail.dts";
	emap = true;
	
	canPickup = false;
};

datablock ItemData(log_dropable_Item)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "./log.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiname = "Log";
	
	image = log_dropable_Image;
	candrop = true;
	canPickup = false;
};

datablock ShapeBaseImageData(log_dropable_Image)
{
	shapeFile = "./log.dts";
	emap = true;
	
	canPickup = false;
};

datablock ItemData(brace_dropable_Item)
{
	category = "Weapon";
	className = "Weapon";
	
	shapeFile = "./brace.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
	uiname = "Brace";
	
	image = brace_dropable_Image;
	candrop = true;
	canPickup = false;
};

datablock ShapeBaseImageData(brace_dropable_Image)
{
	shapeFile = "./brace.dts";
	emap = true;
	
	canPickup = false;
};

datablock ParticleData(repairBarricadeParticle)
{
	dragCoefficient		= 1.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 1.3;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1200;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;

	textureName		= "base/data/particles/dot";
	colors[0]	= "0.0 1 0.0 0.5";
	colors[1]	= "0.0 1 0.0 1.0";
   	colors[2]	= "0.0 1 0.0 0.3";

	sizes[0]	= 0.1;
	sizes[1]	= 0.12;
   	sizes[2]	= 0.13;

	times[0]	= 0.0;
};

datablock ParticleEmitterData(repairBarricadeEmitter)
{
   ejectionPeriodMS = 15;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 1.0;
   thetaMin         = 10;
   thetaMax         = 30;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "repairBarricadeParticle";
};

datablock ExplosionData(repairBarricadeExplosion)
{
	soundProfile = wrenchHitSound;
	particleEmitter = repairBarricadeEmitter;
	particleDensity = 18;
	particleRadius = 0.02;
};

datablock projectileData(repairBarricadeProjectile)
{
	lifetime = 80;
	projectileShapeName = "base/data/shapes/empty.dts";
	muzzleVelocity = 200;
	directDamage = 0;
	lightStartColor = "0 1 0 1";
	lightEndColor = "0 0 0 0";
	explosion = "repairBarricadeExplosion";
};

datablock itemData(repairBarricadeItem : wrenchItem)
{
	category = "Weapon";
	uiName = "Cade Repair";
	image = repairBarricadeImage;
	colorShiftColor = "0 0.85 0 1.000000";
};

datablock shapeBaseImageData(repairBarricadeImage : wrenchImage)
{
	item = repairBarricadeItem;
	projectile = repairBarricadeProjectile;
	colorShiftColor = repairBarricadeItem.colorShiftColor;
	showBricks = 0;
};

function repairBarricadeImage::onPreFire(%this, %a, %b)
{
	wrenchImage.onPreFire(%a, %b);
}
package repairBarricade
{
	function repairBarricadeProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{	
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		if(%col.getClassName() $= "StaticShape")
		{
			if(%col.getDataBlock().isBarricade)
			{
				%col.repair();
			}
		}
	}
};
activatepackage(repairBarricade);